/* rexx program to dump W3F data to html, fake URL link */

dbusername='user'
dbpasswd='password'
dbserver='192.168.1.2'
dbname='archive_db'

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

Call RxFuncAdd 'SQLLoadFuncs', 'rexxsql', 'SQLLoadFuncs'
Call SQLLoadFuncs

ARG Parm1 Parm2 

if Parm1 = '' then 
 signal syntax

url = Parm1 /* fake URL for aref line */
Outfile = Parm2 /* Output file */

/* --------------------------------------------------------------------------------------- */
 /* set up the output file */
rc = Stream(outfile,'c','open')

/* write the HTML header sections */
oline='<!doctype html public>'
call lineout outfile,oline

oline='<!-- Generated by W3Fdump - Version 0.1 -->'
call lineout outfile,oline

oline='<!-- Most recent revision: 'date('L') ' -->'
call lineout outfile,oline

oline='<Html>'
call lineout outfile,oline

oline='<Head>'
call lineout outfile,oline

oline='<meta name="description" content="Central Core BBS file Archives">'
call lineout outfile,oline

oline = '<meta name="keywords" content="Central Core BBS,cencore,freeware,shareware,files,download">'
call lineout outfile,oline

oline='<Title>Central Core BBS file archive master list</Title>'
call lineout outfile,oline

oline='</Head>'
call lineout outfile,oline

oline='<Body Background="bg.jpg" Link="#000000" Vlink="#000000" Alink="#000000">'
call lineout outfile,oline

oline='<BaseFont Size=3>'
call lineout outfile,oline


/* Connect to the database */
If SQLConnect( 'c1', dbusername, dbpasswd, dbname ,dbserver) < 0 Then Abort( 'connecting' )

If SQLPrepare( 'files', 'select * from files') < 0 Then Abort( 'prepare' )

If SQLOpen( 'files', 'dat') < 0 Then Abort( 'open' )
say sqlca.rowcount
maxrows = sqlca.rowcount

do maxrows

	If SQLFetch( 'files') < 0 Then Abort( 'fetch' )
	say files.filename
/* 	say files.description */
	
  a1='<A HREF="'url'">'
	eline=a1 files.filename'</A> 'files.description '<BR><BR>'

	call lineout outfile, eline

end /* do */


/* write the HTML tail */
oline='</Body>'
call lineout outfile,oline
oline='</Html>'
call lineout outfile,oline

/* close the output file */
rc = Stream(outfile,'c','close')


If SQLClose( 'files') < 0 Then Abort( 'Close' )


If SQLDisconnect( 'c1' ) < 0 Then Abort( 'disconnecting' ) 
Say 'Disconnect succeeded!'


exit

Syntax:
call syscls
say ''
say ''
say 'W3FDUMP .01'
say 'Copyright (C) 2001, Michael W. Cocke - cocke@catherders.com'
say '(Part of the W3F archive system for www)'
say ''

say 'Syntax:'
say 'W3FDUMP URL OutFilePath'
say ''
say 'URL = Input file, PCBoard DIR format.'
say 'OutFilePath = drive & path for the output file.'
say ''
say ''
exit



Abort: Procedure Expose sqlca.
Parse Arg msg
Say 'Program failed:' msg
Say sqlca.interrm
If Datatype( sqlca.sqlerrm.0 ) = 'NUM' Then
   Do i = 1 To sqlca.sqlerrm.0
      Say '('sqlca.sqlstate.i')' sqlca.sqlerrm.i
   End
Else
   Do
      Say '('sqlca.sqlstate')' sqlca.sqlerrm
   End
Call SQLDropFuncs 'UNLOAD'
Exit 1

